searchNodes=[{"doc":"Parses the accept-language header if one is available and sets conn.private[:cldr_locale] accordingly. The locale can be later retrieved by Cldr.Plug.AcceptLanguage.get_cldr_locale/1 Options :cldr_backend is any backend module. The default is Cldr.default_backend/0 . If no :cldr_backend option is provided and no default backend is configured then an exception will be raised. :no_match_log_level determines the logging level for the case when no matching locale is configured to meet the users request. The default is :warn . If set to nil then no logging is performed. Example # Using a specific backend to validate # and match locales plug Cldr.Plug.AcceptLanguage , cldr_backend : MyApp.Cldr # Using the default backend to validate # and match locales plug Cldr.Plug.AcceptLanguage","ref":"Cldr.Plug.AcceptLanguage.html","title":"Cldr.Plug.AcceptLanguage","type":"module"},{"doc":"Returns the locale which is the best match for the provided accept-language header","ref":"Cldr.Plug.AcceptLanguage.html#best_match/2","title":"Cldr.Plug.AcceptLanguage.best_match/2","type":"function"},{"doc":"Return the locale set by Cldr.Plug.AcceptLanguage","ref":"Cldr.Plug.AcceptLanguage.html#get_cldr_locale/1","title":"Cldr.Plug.AcceptLanguage.get_cldr_locale/1","type":"function"},{"doc":"Puts the CLDR locale name in the session. The session key is fixed to be cldr_locale in order that downstream functions like those in liveview don't have to be passed options. Examples # Define a router module that # sets the locale for the current process # and then also sets it in the session defmodule MyAppWeb.Router do use MyAppWeb , :router pipeline :browser do plug :accepts , [ &quot;html&quot; ] plug :fetch_session plug Cldr.Plug.SetLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug Cldr.Plug.PutSession plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end end","ref":"Cldr.Plug.PutSession.html","title":"Cldr.Plug.PutSession","type":"module"},{"doc":"Sets the Cldr and/or Gettext locales derived from the accept-language header, a query parameter, a url parameter, a body parameter or the session. Options :apps - list of apps for which to set locale. See the apps configuration section. :from - where in the request to look for the locale. The default is [:session, :accept_language, :query, :path] . The valid options are: :accept_language will parse the accept-language header and finds the best matched configured locale :path will look for a locale by examining conn.path_params :query will look for a locale by examining conn.query_params :body will look for a locale by examining conn.body_params :cookie will look for a locale in the request cookie(s) :session will look for a locale in the session :host will attempt to resolve a locale from the host name top-level domain using Cldr.Locale.locale_from_host/3 {Module, function, args} in which case the indicated function will be called. If it returns {:ok, locale} then the locale is set to locale . locale must be a t:Cldr.LanguageTag.t() . Any other return is considered an error and no locale will be set. When calling the function, conn and options will be prepended to args . {Module, function} in which case the function is called with conn and options as its two arguments. All other behaviour is the same as that for a {Module, function, args} option. :default - the default locale to set if no locale is found by other configured methods. It can be a string like &quot;en&quot; or a Cldr.LanguageTag struct. It may also be :none to indicate that no locale is to be set by default. Lastly, it may also be a {Module, function, args} or {Module, function} tuple. The default is Cldr.default_locale/1 . If the case of {Module, function, args} , a return of {:ok, %Cldr.LanguageTag{}} will set the locale. Any other return will not set a locale. :gettext - the name of the Gettext backend module upon which the locale will be validated. This option is not required if a gettext module is specified in the :apps configuration. :cldr - the name of the Cldr backend module upon which the locale will be validated. This option is not required if a gettext module is specified in the :apps configuration. :session_key - defines the key used to look for the locale in the session. The default is cldr_locale . This option is deprecated and will be removed in a future release. The session key is being standardised in order to faciliate a simpler integration with Phoenix LiveView by ensuring that the session key is always under a well known key. If a locale is found then conn.private[:cldr_locale] is also set. It can be retrieved with Cldr.Plug.SetLocale.get_cldr_locale/1 . App configuration The :apps configuration key defines which applications will have their locale set by this plug. Cldr.Plug.SetLocale can set the locale for cldr , gettext or both. The basic configuration of the :app key is an atom, or list of atoms, containing one or both of these app names. For example: apps : :cldr apps : :gettext apps : [ :cldr , :gettext ] In each of these cases, the locale is set globally for the current process . Sometimes setting the locale for only a specific backend is required. In this case, configure the :apps key as a keyword list pairing an application with the required backend module. The value :global signifies setting the local for the global context. For example: apps : [ cldr : MyApp.Cldr ] apps : [ gettext : MyAppGettext ] apps : [ gettext : :global ] apps : [ cldr : MyApp.Cldr , gettext : MyAppGettext ] Using Cldr.Plug.SetLocale without Phoenix If you are using Cldr.Plug.SetLocale without Phoenix and you plan to use :path_param to identify the locale of a request then Cldr.Plug.SetLocale must be configured after plug :match and before plug :dispatch . For example: defmodule MyRouter do use Plug.Router plug :match plug Cldr.Plug.SetLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug :dispatch get &quot;/hello/:locale&quot; do send_resp ( conn , 200 , &quot;world&quot; ) end end Using Cldr.Plug.SetLocale with Phoenix If you are using Cldr.Plug.SetLocale with Phoenix and you plan to use the :path_param to identify the locale of a request then Cldr.Plug.SetLocale must be configured in the router module, not in the endpoint module. This is because conn.path_params has not yet been populated in the endpoint. For example: defmodule MyAppWeb.Router do use MyAppWeb , :router pipeline :browser do plug :accepts , [ &quot;html&quot; ] plug :fetch_session plug Cldr.Plug.SetLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end scope &quot;/:locale&quot; , HelloWeb do pipe_through :browser get &quot;/&quot; , PageController , :index end end Examples # Will set the global locale for the current process # for both `:cldr` and `:gettext` plug Cldr.Plug.SetLocale , apps : [ :cldr , :gettext ] , from : [ :query , :path , :body , :cookie , :accept_language ] , param : &quot;locale&quot; , gettext : GetTextModule , cldr : MyApp.Cldr # Will set the backend-only locale for the current process # for both `:cldr` and `:gettext` plug Cldr.Plug.SetLocale , apps : [ cldr : MyApp.Cldr , gettext : GetTextModule ] , from : [ :query , :path , :body , :cookie , :accept_language ] , param : &quot;locale&quot; # Will set the backend-only locale for the current process # for `:cldr` and globally for `:gettext` plug Cldr.Plug.SetLocale , apps : [ cldr : MyApp.Cldr , gettext : :global ] , from : [ :query , :path , :body , :cookie , :accept_language ] , param : &quot;locale&quot;","ref":"Cldr.Plug.SetLocale.html","title":"Cldr.Plug.SetLocale","type":"module"},{"doc":"Return the locale set by Cldr.Plug.SetLocale","ref":"Cldr.Plug.SetLocale.html#get_cldr_locale/1","title":"Cldr.Plug.SetLocale.get_cldr_locale/1","type":"function"},{"doc":"Returns the name of the session key used to store the CLDR locale name. Example iex&gt; Cldr.Plug.SetLocale.session_key() &quot;cldr_locale&quot;","ref":"Cldr.Plug.SetLocale.html#session_key/0","title":"Cldr.Plug.SetLocale.session_key/0","type":"function"},{"doc":"","ref":"readme.html","title":"Cldr Plug","type":"extras"},{"doc":"Cldr provides two plugs to aid integration into an HTTP workflow. These two plugs are: Cldr.Plug.AcceptLanguage which will parse an accept-language header and resolve the best matched and configured Cldr locale. The result is stored in conn.private[:cldr_locale] which is also returned by Cldr.Plug.AcceptLanguage.get_cldr_locale/1 . Cldr.Plug.SetLocale which will look for a locale in the several places and then call Cldr.put_locale/2 and Gettext.put_locale/2 if configured so to do. Finally, The result is stored in conn.private[:cldr_locale] which is then available through Cldr.Plug.SetLocale.get_cldr_locale/1 . The plug will look for a locale in the following locations depending on the plug configuration: path_params query_params body_params cookies accept-language header Hostname suffix the session An {Module, function, [args]} or {Module, function} tuple that should return {:ok, Cldr.LanguageTag.t()} - any other return will not set the locale. See Cldr.Plug.SetLocale for a description of how to configure the plug. In addition, note that when migrating from ex_cldr 1.x versions, a backend needs to be configured for both plugs. In the simplest case an example would be: plug Cldr.Plug.SetLocale , apps : [ :cldr ] , cldr : MyApp.Cldr plug Cldr.Plug.AcceptLanguage , cldr_backend : MyApp.Cldr Using Cldr.Plug.SetLocale without Phoenix If you are using Cldr.Plug.SetLocale without Phoenix and you plan to use :path_param to identify the locale of a request then Cldr.Plug.SetLocale must be configured after plug :match and before plug :dispatch . For example: defmodule MyRouter do use Plug.Router plug :match plug Cldr.Plug.SetLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug :dispatch get &quot;/hello/:locale&quot; do send_resp ( conn , 200 , &quot;world&quot; ) end end Using Cldr.Plug.SetLocale with Phoenix If you are using Cldr.Plug.SetLocale with Phoenix and you plan to use the :path_param to identify the locale of a request then Cldr.Plug.SetLocale must be configured in the router module, not in the endpoint module. This is because conn.path_params has not yet been populated in the endpoint. For example: defmodule MyAppWeb.Router do use MyAppWeb , :router pipeline :browser do plug :accepts , [ &quot;html&quot; ] plug :fetch_session plug Cldr.Plug.SetLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end scope &quot;/:locale&quot; , HelloWeb do pipe_through :browser get &quot;/&quot; , PageController , :index end end","ref":"readme.html#plugs","title":"Cldr Plug - Plugs","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Cldr Plugs v1.0.0 released on May 10th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Intiial release, extracted from ex_cldr Adds support for MFA (and the variant without arguments MF ) tuples that can be used as part of the Cldr.Plug.SetLocale configuration in the :from and :default cases.","ref":"changelog.html#cldr-plugs-v1-0-0","title":"Changelog - Cldr Plugs v1.0.0","type":"extras"},{"doc":"","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Copyright 2017 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html#license","title":"LICENSE - License","type":"extras"}]